Index: /trunk/sources/HeuristicLab.Core.Views/3.3/CheckedItemCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/CheckedItemCollectionView.cs	(revision 3561)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/CheckedItemCollectionView.cs	(revision 3562)
@@ -56,5 +56,5 @@
       Content.ItemsRemoved -= new CollectionItemsChangedEventHandler<T>(Content_ItemsRemoved);
       Content.CollectionReset -= new CollectionItemsChangedEventHandler<T>(Content_CollectionReset);
-      Content.ItemsChecked -= new CollectionItemsChangedEventHandler<T>(Content_ItemsChecked);
+      Content.CheckedItemsChanged -= new CollectionItemsChangedEventHandler<T>(Content_ItemsChecked);
       base.DeregisterContentEvents();
     }
@@ -64,5 +64,5 @@
       Content.ItemsRemoved += new CollectionItemsChangedEventHandler<T>(Content_ItemsRemoved);
       Content.CollectionReset += new CollectionItemsChangedEventHandler<T>(Content_CollectionReset);
-      Content.ItemsChecked += new CollectionItemsChangedEventHandler<T>(Content_ItemsChecked);
+      Content.CheckedItemsChanged += new CollectionItemsChangedEventHandler<T>(Content_ItemsChecked);
     }
 
@@ -299,6 +299,6 @@
         foreach (T item in e.Items) {
           foreach (ListViewItem listViewItem in GetListViewItemsForItem(item)) {
-            if (listViewItem.Checked != Content.IsItemChecked(item))
-              listViewItem.Checked = Content.IsItemChecked(item);
+            if (listViewItem.Checked != Content.ItemChecked(item))
+              listViewItem.Checked = Content.ItemChecked(item);
           }
         }
Index: /trunk/sources/HeuristicLab.Core/3.3/Collections/CheckedItemCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Collections/CheckedItemCollection.cs	(revision 3561)
+++ /trunk/sources/HeuristicLab.Core/3.3/Collections/CheckedItemCollection.cs	(revision 3562)
@@ -60,5 +60,5 @@
     protected CheckedItemCollection(bool deserializing) : base(deserializing) { }
 
-    public bool IsItemChecked(T item) {
+    public bool ItemChecked(T item) {
       return checkedState[item];
     }
@@ -76,5 +76,6 @@
         checkedState.Remove(oldItem);
       foreach (var item in items)
-        checkedState.Add(item, false);
+        if (!checkedState.ContainsKey(item))
+          checkedState.Add(item, false);
       base.OnCollectionReset(items, oldItems);
     }
@@ -82,5 +83,6 @@
     protected override void OnItemsAdded(IEnumerable<T> items) {
       foreach (var item in items)
-        checkedState.Add(item, false);
+        if (!checkedState.ContainsKey(item))
+          checkedState.Add(item, false);
       base.OnItemsAdded(items);
     }
@@ -94,10 +96,10 @@
 
     protected virtual void OnItemsChecked(IEnumerable<T> items) {
-      RaiseItemsChecked(new CollectionItemsChangedEventArgs<T>(items));
+      RaiseCheckedItemsChanged(new CollectionItemsChangedEventArgs<T>(items));
     }
 
-    public event CollectionItemsChangedEventHandler<T> ItemsChecked;
-    private void RaiseItemsChecked(CollectionItemsChangedEventArgs<T> e) {
-      var handler = ItemsChecked;
+    public event CollectionItemsChangedEventHandler<T> CheckedItemsChanged;
+    private void RaiseCheckedItemsChanged(CollectionItemsChangedEventArgs<T> e) {
+      var handler = CheckedItemsChanged;
       if (handler != null) handler(this, e);
     }
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/ICheckedItemCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/ICheckedItemCollection.cs	(revision 3561)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/ICheckedItemCollection.cs	(revision 3562)
@@ -24,8 +24,8 @@
 
 namespace HeuristicLab.Core {
-  public interface ICheckedItemCollection<T> : IItemCollection<T>, IItem where T : class, IItem {
-    event CollectionItemsChangedEventHandler<T> ItemsChecked;
+  public interface ICheckedItemCollection<T> : IItemCollection<T> where T : class, IItem {
+    event CollectionItemsChangedEventHandler<T> CheckedItemsChanged;
     IEnumerable<T> CheckedItems { get; }
-    bool IsItemChecked(T item);
+    bool ItemChecked(T item);
     void SetItemCheckedState(T item, bool checkedState);
   }