Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.cs	(revision 3566)
@@ -49,12 +49,4 @@
     public AlgorithmView() {
       InitializeComponent();
-    }
-    /// <summary>
-    /// Intializes a new instance of <see cref="ItemBaseView"/> with the given <paramref name="item"/>.
-    /// </summary>
-    /// <param name="item">The item that should be displayed.</param>
-    public AlgorithmView(IAlgorithm content)
-      : this() {
-      Content = content;
     }
 
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.cs	(revision 3566)
@@ -47,12 +47,4 @@
     public BatchRunView() {
       InitializeComponent();
-    }
-    /// <summary>
-    /// Intializes a new instance of <see cref="ItemBaseView"/> with the given <paramref name="item"/>.
-    /// </summary>
-    /// <param name="item">The item that should be displayed.</param>
-    public BatchRunView(BatchRun content)
-      : this() {
-      Content = content;
     }
 
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs	(revision 3566)
@@ -47,13 +47,4 @@
     public EngineAlgorithmView() {
       InitializeComponent();
-    }
-
-    /// <summary>
-    /// Intializes a new instance of <see cref="ItemBaseView"/> with the given <paramref name="item"/>.
-    /// </summary>
-    /// <param name="item">The item that should be displayed.</param>
-    public EngineAlgorithmView(EngineAlgorithm content)
-      : this() {
-      Content = content;
     }
 
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/ExperimentView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/ExperimentView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/ExperimentView.cs	(revision 3566)
@@ -44,12 +44,4 @@
     public ExperimentView() {
       InitializeComponent();
-    }
-    /// <summary>
-    /// Intializes a new instance of <see cref="ItemBaseView"/> with the given <paramref name="item"/>.
-    /// </summary>
-    /// <param name="item">The item that should be displayed.</param>
-    public ExperimentView(Experiment content)
-      : this() {
-      Content = content;
     }
 
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/OptimizerListView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/OptimizerListView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/OptimizerListView.cs	(revision 3566)
@@ -40,14 +40,4 @@
       itemsGroupBox.Text = "Optimizers";
     }
-    /// <summary>
-    /// Initializes a new instance of <see cref="VariablesScopeView"/> with 
-    /// the given <paramref name="scope"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="VariablesScopeView()"/>.</remarks>
-    /// <param name="scope">The scope whose variables should be represented visually.</param>
-    public OptimizerListView(IItemList<IOptimizer> content)
-      : this() {
-      Content = content;
-    }
 
     protected override IOptimizer CreateItem() {
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/ProblemView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/ProblemView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/ProblemView.cs	(revision 3566)
@@ -41,12 +41,4 @@
       InitializeComponent();
     }
-    /// <summary>
-    /// Intializes a new instance of <see cref="ItemBaseView"/> with the given <paramref name="item"/>.
-    /// </summary>
-    /// <param name="item">The item that should be displayed.</param>
-    public ProblemView(IProblem content)
-      : this() {
-      Content = content;
-    }
 
     protected override void OnContentChanged() {
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultCollectionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultCollectionView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultCollectionView.cs	(revision 3566)
@@ -44,14 +44,4 @@
       base.ReadOnly = true;
     }
-    /// <summary>
-    /// Initializes a new instance of <see cref="VariablesScopeView"/> with 
-    /// the given <paramref name="scope"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="VariablesScopeView()"/>.</remarks>
-    /// <param name="scope">The scope whose variables should be represented visually.</param>
-    public ResultCollectionView(IKeyedItemCollection<string, IResult> content)
-      : this() {
-      Content = content;
-    }
 
     protected override IResult CreateItem() {
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultView.cs	(revision 3566)
@@ -57,13 +57,4 @@
       base.ReadOnly = true;
     }
-    /// <summary>
-    /// Initializes a new instance of <see cref="VariableView"/> with the given <paramref name="variable"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="VariableView()"/>.</remarks>
-    /// <param name="variable">The variable to represent visually.</param>
-    public ResultView(IResult content)
-      : this() {
-      Content = content;
-    }
 
     /// <summary>
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs	(revision 3566)
@@ -74,9 +74,4 @@
     }
 
-    public RunCollectionBubbleChartView(RunCollection content)
-      : this() {
-      Content = content;
-    }
-
     public new RunCollection Content {
       get { return (RunCollection)base.Content; }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionTabularView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionTabularView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionTabularView.cs	(revision 3566)
@@ -42,9 +42,4 @@
       this.dataGridView.RowHeaderMouseDoubleClick += new DataGridViewCellMouseEventHandler(dataGridView_RowHeaderMouseDoubleClick);
       base.ReadOnly = true;
-    }
-
-    public RunCollectionTabularView(RunCollection content)
-      : this() {
-      Content = content;
     }
 
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 3566)
@@ -52,9 +52,4 @@
     }
 
-    public RunCollectionView(IItemCollection<IRun> content)
-      : this() {
-      Content = content;
-    }
-
     protected override void DeregisterContentEvents() {
       Content.ItemsAdded -= new CollectionItemsChangedEventHandler<IRun>(Content_ItemsAdded);
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 3566)
@@ -56,13 +56,4 @@
       Caption = "Run";
       base.ReadOnly = true;
-    }
-    /// <summary>
-    /// Initializes a new instance of <see cref="VariableView"/> with the given <paramref name="variable"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="VariableView()"/>.</remarks>
-    /// <param name="variable">The variable to represent visually.</param>
-    public RunView(IRun content)
-      : this() {
-      Content = content;
     }
 
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs	(revision 3557)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs	(revision 3566)
@@ -45,12 +45,4 @@
     public UserDefinedAlgorithmView() {
       InitializeComponent();
-    }
-    /// <summary>
-    /// Intializes a new instance of <see cref="ItemBaseView"/> with the given <paramref name="item"/>.
-    /// </summary>
-    /// <param name="item">The item that should be displayed.</param>
-    public UserDefinedAlgorithmView(UserDefinedAlgorithm content)
-      : this() {
-      Content = content;
     }
 