Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLab.MainForm.WindowsForms-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLab.MainForm.WindowsForms-3.3.csproj	(revision 3571)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLab.MainForm.WindowsForms-3.3.csproj	(revision 3572)
@@ -164,4 +164,10 @@
       <DependentUpon>ViewHost.cs</DependentUpon>
     </Compile>
+    <Compile Include="ViewHostPanel.cs">
+      <SubType>Component</SubType>
+    </Compile>
+    <Compile Include="ViewHostPanel.Designer.cs">
+      <DependentUpon>ViewHostPanel.cs</DependentUpon>
+    </Compile>
   </ItemGroup>
   <ItemGroup>
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHost.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHost.Designer.cs	(revision 3571)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHost.Designer.cs	(revision 3572)
@@ -47,5 +47,5 @@
       this.components = new System.ComponentModel.Container();
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ViewHost));
-      this.viewPanel = new System.Windows.Forms.Panel();
+      this.viewPanel = new ViewHostPanel();
       this.messageLabel = new System.Windows.Forms.Label();
       this.viewsLabel = new System.Windows.Forms.Label();
@@ -111,5 +111,5 @@
     #endregion
 
-    private System.Windows.Forms.Panel viewPanel;
+    private ViewHostPanel viewPanel;
     private System.Windows.Forms.Label viewsLabel;
     private System.Windows.Forms.Label messageLabel;
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHost.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHost.cs	(revision 3571)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHost.cs	(revision 3572)
@@ -107,5 +107,5 @@
       viewPanel.Visible = false;
       viewContextMenuStrip.Item = Content;
-      
+
       if (Content != null) {
         if (viewContextMenuStrip.Items.Count == 0)
@@ -177,5 +177,4 @@
       }
     }
-
     #region forwarding of view events
     protected override void OnReadOnlyChanged() {
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHostPanel.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHostPanel.Designer.cs	(revision 3572)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHostPanel.Designer.cs	(revision 3572)
@@ -0,0 +1,31 @@
+﻿namespace HeuristicLab.MainForm.WindowsForms {
+  partial class ViewHostPanel {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+    }
+
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHostPanel.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHostPanel.cs	(revision 3572)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHostPanel.cs	(revision 3572)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+
+namespace HeuristicLab.MainForm.WindowsForms {
+  public partial class ViewHostPanel : Panel {
+    public ViewHostPanel() {
+      InitializeComponent();
+    }
+
+    protected override void OnSizeChanged(EventArgs e) {
+      //mkommend: solution to resizing issues. taken from http://support.microsoft.com/kb/953934
+      if (this.Handle != null)
+        this.BeginInvoke((MethodInvoker)delegate { base.OnSizeChanged(e); });
+
+    }
+  }
+}