Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerForm.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerForm.Designer.cs	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerForm.Designer.cs	(revision 3600)
@@ -63,7 +63,4 @@
       this.logTextBox = new System.Windows.Forms.TextBox();
       this.menuStrip = new System.Windows.Forms.MenuStrip();
-      this.viewToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.simpleToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.advancedToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.optionsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.connectionSettingsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
@@ -119,5 +116,4 @@
       this.tabControl.Size = new System.Drawing.Size(598, 392);
       this.tabControl.TabIndex = 16;
-      this.tabControl.Selected += new System.Windows.Forms.TabControlEventHandler(this.tabControl_Selected);
       // 
       // updateAllPluginsTabPage
@@ -272,5 +268,4 @@
       // 
       this.menuStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
-            this.viewToolStripMenuItem,
             this.optionsToolStripMenuItem});
       this.menuStrip.Location = new System.Drawing.Point(0, 0);
@@ -279,32 +274,4 @@
       this.menuStrip.TabIndex = 17;
       this.menuStrip.Text = "menuStrip1";
-      // 
-      // viewToolStripMenuItem
-      // 
-      this.viewToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
-            this.simpleToolStripMenuItem,
-            this.advancedToolStripMenuItem});
-      this.viewToolStripMenuItem.Name = "viewToolStripMenuItem";
-      this.viewToolStripMenuItem.Size = new System.Drawing.Size(44, 20);
-      this.viewToolStripMenuItem.Text = "View";
-      this.viewToolStripMenuItem.Visible = false;
-      // 
-      // simpleToolStripMenuItem
-      // 
-      this.simpleToolStripMenuItem.Checked = true;
-      this.simpleToolStripMenuItem.CheckOnClick = true;
-      this.simpleToolStripMenuItem.CheckState = System.Windows.Forms.CheckState.Checked;
-      this.simpleToolStripMenuItem.Name = "simpleToolStripMenuItem";
-      this.simpleToolStripMenuItem.Size = new System.Drawing.Size(214, 22);
-      this.simpleToolStripMenuItem.Text = "Show Most Recent Plugins";
-      this.simpleToolStripMenuItem.Click += new System.EventHandler(this.simpleToolStripMenuItem_Click);
-      // 
-      // advancedToolStripMenuItem
-      // 
-      this.advancedToolStripMenuItem.CheckOnClick = true;
-      this.advancedToolStripMenuItem.Name = "advancedToolStripMenuItem";
-      this.advancedToolStripMenuItem.Size = new System.Drawing.Size(214, 22);
-      this.advancedToolStripMenuItem.Text = "Show All Plugins";
-      this.advancedToolStripMenuItem.Click += new System.EventHandler(this.advancedToolStripMenuItem_Click);
       // 
       // optionsToolStripMenuItem
@@ -365,7 +332,4 @@
     private System.Windows.Forms.TextBox logTextBox;
     private System.Windows.Forms.MenuStrip menuStrip;
-    private System.Windows.Forms.ToolStripMenuItem viewToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem simpleToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem advancedToolStripMenuItem;
     private System.Windows.Forms.ToolStripMenuItem optionsToolStripMenuItem;
     private System.Windows.Forms.ToolStripMenuItem connectionSettingsToolStripMenuItem;
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerForm.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerForm.cs	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerForm.cs	(revision 3600)
@@ -29,4 +29,5 @@
 using System.IO;
 using HeuristicLab.PluginInfrastructure.Manager;
+using System.Diagnostics;
 
 namespace HeuristicLab.PluginInfrastructure.Advanced {
@@ -38,5 +39,6 @@
     public InstallationManagerForm(PluginManager pluginManager) {
       InitializeComponent();
-      Text = "HeuristicLab Plugin Manager " + GetType().Assembly.GetName().Version.ToString();
+      FileVersionInfo pluginInfrastructureVersion = FileVersionInfo.GetVersionInfo(GetType().Assembly.Location);
+      Text = "HeuristicLab Plugin Manager " + pluginInfrastructureVersion.FileVersion;
       
       this.pluginManager = pluginManager;
@@ -138,20 +140,4 @@
       new ConnectionSetupView().ShowDialog();
     }
-
-    private void tabControl_Selected(object sender, TabControlEventArgs e) {
-      viewToolStripMenuItem.Visible = e.TabPage == availablePluginsTabPage;
-      toolStripStatusLabel.Text = string.Empty;
-      toolStripProgressBar.Visible = false;
-    }
-
-    private void simpleToolStripMenuItem_Click(object sender, EventArgs e) {
-      remotePluginInstaller.ShowAllPlugins = false;
-      advancedToolStripMenuItem.Checked = false;
-    }
-
-    private void advancedToolStripMenuItem_Click(object sender, EventArgs e) {
-      remotePluginInstaller.ShowAllPlugins = true;
-      simpleToolStripMenuItem.Checked = false;
-    }
     #endregion
 
Index: unk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.Designer.cs	(revision 3599)
+++ 	(revision )
@@ -1,112 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-namespace HeuristicLab.PluginInfrastructure.Advanced {
-  partial class LocalPluginManagerView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      System.Windows.Forms.ListViewGroup listViewGroup1 = new System.Windows.Forms.ListViewGroup("Active Plugins", System.Windows.Forms.HorizontalAlignment.Left);
-      System.Windows.Forms.ListViewGroup listViewGroup2 = new System.Windows.Forms.ListViewGroup("Disabled Plugins", System.Windows.Forms.HorizontalAlignment.Left);
-      this.localPluginsListView = new HeuristicLab.PluginInfrastructure.Advanced.MultiSelectListView();
-      this.nameHeader = new System.Windows.Forms.ColumnHeader();
-      this.versionHeader = new System.Windows.Forms.ColumnHeader();
-      this.descriptionHeader = new System.Windows.Forms.ColumnHeader();
-      this.SuspendLayout();
-      // 
-      // localPluginsListView
-      // 
-      this.localPluginsListView.CheckBoxes = true;
-      this.localPluginsListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
-            this.nameHeader,
-            this.versionHeader,
-            this.descriptionHeader});
-      this.localPluginsListView.Dock = System.Windows.Forms.DockStyle.Fill;
-      listViewGroup1.Header = "Active Plugins";
-      listViewGroup1.Name = "activePluginsGroup";
-      listViewGroup2.Header = "Disabled Plugins";
-      listViewGroup2.Name = "disabledPluginsGroup";
-      this.localPluginsListView.Groups.AddRange(new System.Windows.Forms.ListViewGroup[] {
-            listViewGroup1,
-            listViewGroup2});
-      this.localPluginsListView.Location = new System.Drawing.Point(0, 0);
-      this.localPluginsListView.Name = "localPluginsListView";
-      this.localPluginsListView.Size = new System.Drawing.Size(570, 547);
-      this.localPluginsListView.SuppressItemCheckedEvents = false;
-      this.localPluginsListView.TabIndex = 9;
-      this.localPluginsListView.UseCompatibleStateImageBehavior = false;
-      this.localPluginsListView.View = System.Windows.Forms.View.Details;
-      //this.localPluginsListView.ItemActivate += new System.EventHandler(this.localPluginsListView_ItemActivate);
-      //this.localPluginsListView.ItemChecked += new System.Windows.Forms.ItemCheckedEventHandler(this.pluginsListView_ItemChecked);
-      // 
-      // nameHeader
-      // 
-      this.nameHeader.Text = "Name";
-      this.nameHeader.Width = 155;
-      // 
-      // versionHeader
-      // 
-      this.versionHeader.Text = "Version";
-      this.versionHeader.Width = 92;
-      // 
-      // descriptionHeader
-      // 
-      this.descriptionHeader.Text = "Description";
-      this.descriptionHeader.Width = 316;
-      // 
-      // LocalPluginManagerView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.localPluginsListView);
-      this.Name = "LocalPluginManagerView";
-      this.Size = new System.Drawing.Size(570, 547);
-      this.ResumeLayout(false);
-
-    }
-
-    #endregion
-
-    private MultiSelectListView localPluginsListView;
-    private System.Windows.Forms.ColumnHeader nameHeader;
-    private System.Windows.Forms.ColumnHeader versionHeader;
-    private System.Windows.Forms.ColumnHeader descriptionHeader;
-  }
-}
Index: unk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.cs	(revision 3599)
+++ 	(revision )
@@ -1,44 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Linq;
-using System.Text;
-using System.Windows.Forms;
-using HeuristicLab.PluginInfrastructure.Manager;
-
-namespace HeuristicLab.PluginInfrastructure.Advanced {
-  internal partial class LocalPluginManagerView : UserControl {
-
-    public event ItemCheckedEventHandler ItemChecked;
-
-
-    public LocalPluginManagerView() {
-      InitializeComponent();
-
-      
-    }
-    
-  }
-}
Index: unk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.resx
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.resx	(revision 3599)
+++ 	(revision )
@@ -1,120 +1,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<root>
-  <!-- 
-    Microsoft ResX Schema 
-    
-    Version 2.0
-    
-    The primary goals of this format is to allow a simple XML format 
-    that is mostly human readable. The generation and parsing of the 
-    various data types are done through the TypeConverter classes 
-    associated with the data types.
-    
-    Example:
-    
-    ... ado.net/XML headers & schema ...
-    <resheader name="resmimetype">text/microsoft-resx</resheader>
-    <resheader name="version">2.0</resheader>
-    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
-    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
-    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
-    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
-    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
-        <value>[base64 mime encoded serialized .NET Framework object]</value>
-    </data>
-    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
-        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
-        <comment>This is a comment</comment>
-    </data>
-                
-    There are any number of "resheader" rows that contain simple 
-    name/value pairs.
-    
-    Each data row contains a name, and value. The row also contains a 
-    type or mimetype. Type corresponds to a .NET class that support 
-    text/value conversion through the TypeConverter architecture. 
-    Classes that don't support this are serialized and stored with the 
-    mimetype set.
-    
-    The mimetype is used for serialized objects, and tells the 
-    ResXResourceReader how to depersist the object. This is currently not 
-    extensible. For a given mimetype the value must be set accordingly:
-    
-    Note - application/x-microsoft.net.object.binary.base64 is the format 
-    that the ResXResourceWriter will generate, however the reader can 
-    read any of the formats listed below.
-    
-    mimetype: application/x-microsoft.net.object.binary.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
-            : and then encoded with base64 encoding.
-    
-    mimetype: application/x-microsoft.net.object.soap.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
-            : and then encoded with base64 encoding.
-
-    mimetype: application/x-microsoft.net.object.bytearray.base64
-    value   : The object must be serialized into a byte array 
-            : using a System.ComponentModel.TypeConverter
-            : and then encoded with base64 encoding.
-    -->
-  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
-    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
-    <xsd:element name="root" msdata:IsDataSet="true">
-      <xsd:complexType>
-        <xsd:choice maxOccurs="unbounded">
-          <xsd:element name="metadata">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" />
-              </xsd:sequence>
-              <xsd:attribute name="name" use="required" type="xsd:string" />
-              <xsd:attribute name="type" type="xsd:string" />
-              <xsd:attribute name="mimetype" type="xsd:string" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="assembly">
-            <xsd:complexType>
-              <xsd:attribute name="alias" type="xsd:string" />
-              <xsd:attribute name="name" type="xsd:string" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="data">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
-              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
-              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="resheader">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" />
-            </xsd:complexType>
-          </xsd:element>
-        </xsd:choice>
-      </xsd:complexType>
-    </xsd:element>
-  </xsd:schema>
-  <resheader name="resmimetype">
-    <value>text/microsoft-resx</value>
-  </resheader>
-  <resheader name="version">
-    <value>2.0</value>
-  </resheader>
-  <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-  <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-</root>
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginsView.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginsView.cs	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginsView.cs	(revision 3600)
@@ -156,4 +156,9 @@
       removeButton.Enabled = localPluginsListView.CheckedItems.Count > 0;
       updateSelectedButton.Enabled = localPluginsListView.CheckedItems.Count > 0;
+      foreach (ColumnHeader column in localPluginsListView.Columns) {
+        if (localPluginsListView.Items.Count > 0)
+          column.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        else column.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
+      }
     }
 
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginEditor.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginEditor.cs	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginEditor.cs	(revision 3600)
@@ -97,5 +97,7 @@
         }
         foreach (ColumnHeader column in listView.Columns)
-          column.Width = -1;
+          if (listView.Items.Count > 0)
+            column.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+          else column.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
         //listView.suppressCheckedEvents = false;
         listView.CheckBoxes = true;
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginListView.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginListView.cs	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginListView.cs	(revision 3600)
@@ -74,5 +74,6 @@
         }
         foreach (ColumnHeader column in listView.Columns)
-          column.Width = -1;
+          column.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+
         listView.SuppressItemCheckedEvents = false;
       }
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.cs	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.cs	(revision 3600)
@@ -89,4 +89,15 @@
         filesListView.Items.Add(fileItem);
       }
+      foreach (ColumnHeader column in dependenciesListView.Columns) {
+        if (dependenciesListView.Items.Count > 0)
+          column.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        else column.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
+      }
+      foreach (ColumnHeader column in filesListView.Columns) {
+        if (filesListView.Items.Count > 0)
+          column.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        else
+          column.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
+      }
       licenseButton.Enabled = !string.IsNullOrEmpty(plugin.LicenseText);
     }
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.cs	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.cs	(revision 3600)
@@ -229,4 +229,9 @@
         }
       }
+      foreach (ColumnHeader column in remotePluginsListView.Columns)
+        if (remotePluginsListView.Items.Count > 0)
+          column.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        else column.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
+
       remotePluginsListView.SuppressItemCheckedEvents = false;
     }
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.Designer.cs	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.Designer.cs	(revision 3600)
@@ -47,6 +47,6 @@
       this.components = new System.ComponentModel.Container();
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(StarterForm));
-      System.Windows.Forms.ListViewGroup listViewGroup1 = new System.Windows.Forms.ListViewGroup("Applications", System.Windows.Forms.HorizontalAlignment.Left);
-      System.Windows.Forms.ListViewGroup listViewGroup2 = new System.Windows.Forms.ListViewGroup("Plugin Management", System.Windows.Forms.HorizontalAlignment.Left);
+      System.Windows.Forms.ListViewGroup listViewGroup3 = new System.Windows.Forms.ListViewGroup("Applications", System.Windows.Forms.HorizontalAlignment.Left);
+      System.Windows.Forms.ListViewGroup listViewGroup4 = new System.Windows.Forms.ListViewGroup("Plugin Management", System.Windows.Forms.HorizontalAlignment.Left);
       this.startButton = new System.Windows.Forms.Button();
       this.largeImageList = new System.Windows.Forms.ImageList(this.components);
@@ -57,8 +57,6 @@
       this.smallImageList = new System.Windows.Forms.ImageList(this.components);
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.showListButton = new System.Windows.Forms.RadioButton();
+      this.showLargeIconsButton = new System.Windows.Forms.RadioButton();
       this.showDetailsButton = new System.Windows.Forms.RadioButton();
-      this.groupBox = new System.Windows.Forms.GroupBox();
-      this.groupBox.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -67,5 +65,5 @@
       this.startButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.startButton.Enabled = false;
-      this.startButton.Location = new System.Drawing.Point(579, 507);
+      this.startButton.Location = new System.Drawing.Point(579, 511);
       this.startButton.Name = "startButton";
       this.startButton.Size = new System.Drawing.Size(75, 23);
@@ -91,11 +89,11 @@
             this.versionColumnHeader,
             this.descriptionColumnHeader});
-      listViewGroup1.Header = "Applications";
-      listViewGroup1.Name = "Applications";
-      listViewGroup2.Header = "Plugin Management";
-      listViewGroup2.Name = "Plugin Management";
+      listViewGroup3.Header = "Applications";
+      listViewGroup3.Name = "Applications";
+      listViewGroup4.Header = "Plugin Management";
+      listViewGroup4.Name = "Plugin Management";
       this.applicationsListView.Groups.AddRange(new System.Windows.Forms.ListViewGroup[] {
-            listViewGroup1,
-            listViewGroup2});
+            listViewGroup3,
+            listViewGroup4});
       this.applicationsListView.LargeImageList = this.largeImageList;
       this.applicationsListView.Location = new System.Drawing.Point(12, 12);
@@ -103,7 +101,7 @@
       this.applicationsListView.Name = "applicationsListView";
       this.applicationsListView.ShowItemToolTips = true;
-      this.applicationsListView.Size = new System.Drawing.Size(642, 479);
+      this.applicationsListView.Size = new System.Drawing.Size(642, 493);
       this.applicationsListView.SmallImageList = this.smallImageList;
-      this.applicationsListView.TabIndex = 2;
+      this.applicationsListView.TabIndex = 0;
       this.applicationsListView.UseCompatibleStateImageBehavior = false;
       this.applicationsListView.ItemActivate += new System.EventHandler(this.applicationsListView_ItemActivate);
@@ -130,40 +128,30 @@
       this.smallImageList.Images.SetKeyName(0, "HeuristicLab.ico");
       // 
-      // showListButton
+      // showLargeIconsButton
       // 
-      this.showListButton.Appearance = System.Windows.Forms.Appearance.Button;
-      this.showListButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.show_icons;
-      this.showListButton.Location = new System.Drawing.Point(6, 9);
-      this.showListButton.Name = "showListButton";
-      this.showListButton.Size = new System.Drawing.Size(25, 25);
-      this.showListButton.TabIndex = 3;
-      this.showListButton.TabStop = true;
-      this.toolTip.SetToolTip(this.showListButton, "Show List");
-      this.showListButton.UseVisualStyleBackColor = true;
-      this.showListButton.Click += new System.EventHandler(this.largeIconsButton_Click);
+      this.showLargeIconsButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.showLargeIconsButton.Appearance = System.Windows.Forms.Appearance.Button;
+      this.showLargeIconsButton.Checked = true;
+      this.showLargeIconsButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.show_icons;
+      this.showLargeIconsButton.Location = new System.Drawing.Point(12, 511);
+      this.showLargeIconsButton.Name = "showLargeIconsButton";
+      this.showLargeIconsButton.Size = new System.Drawing.Size(23, 23);
+      this.showLargeIconsButton.TabIndex = 2;
+      this.toolTip.SetToolTip(this.showLargeIconsButton, "Show Large Icons");
+      this.showLargeIconsButton.UseVisualStyleBackColor = false;
+      this.showLargeIconsButton.Click += new System.EventHandler(this.largeIconsButton_Click);
       // 
       // showDetailsButton
       // 
+      this.showDetailsButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.showDetailsButton.Appearance = System.Windows.Forms.Appearance.Button;
       this.showDetailsButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.show_details;
-      this.showDetailsButton.Location = new System.Drawing.Point(37, 9);
+      this.showDetailsButton.Location = new System.Drawing.Point(41, 511);
       this.showDetailsButton.Name = "showDetailsButton";
-      this.showDetailsButton.Size = new System.Drawing.Size(25, 25);
-      this.showDetailsButton.TabIndex = 4;
-      this.showDetailsButton.TabStop = true;
+      this.showDetailsButton.Size = new System.Drawing.Size(23, 23);
+      this.showDetailsButton.TabIndex = 3;
       this.toolTip.SetToolTip(this.showDetailsButton, "Show Details");
-      this.showDetailsButton.UseVisualStyleBackColor = true;
+      this.showDetailsButton.UseVisualStyleBackColor = false;
       this.showDetailsButton.Click += new System.EventHandler(this.detailsButton_Click);
-      // 
-      // groupBox
-      // 
-      this.groupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.groupBox.Controls.Add(this.showListButton);
-      this.groupBox.Controls.Add(this.showDetailsButton);
-      this.groupBox.Location = new System.Drawing.Point(12, 497);
-      this.groupBox.Name = "groupBox";
-      this.groupBox.Size = new System.Drawing.Size(68, 37);
-      this.groupBox.TabIndex = 5;
-      this.groupBox.TabStop = false;
       // 
       // StarterForm
@@ -172,5 +160,6 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.ClientSize = new System.Drawing.Size(666, 546);
-      this.Controls.Add(this.groupBox);
+      this.Controls.Add(this.showDetailsButton);
+      this.Controls.Add(this.showLargeIconsButton);
       this.Controls.Add(this.applicationsListView);
       this.Controls.Add(this.startButton);
@@ -179,5 +168,4 @@
       this.Text = "HeuristicLab Starter";
       this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MainForm_FormClosing);
-      this.groupBox.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -194,7 +182,6 @@
     private System.Windows.Forms.ImageList smallImageList;
     private System.Windows.Forms.ToolTip toolTip;
-    private System.Windows.Forms.RadioButton showListButton;
+    private System.Windows.Forms.RadioButton showLargeIconsButton;
     private System.Windows.Forms.RadioButton showDetailsButton;
-    private System.Windows.Forms.GroupBox groupBox;
   }
 }
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.cs	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.cs	(revision 3600)
@@ -54,5 +54,6 @@
       : base() {
       InitializeComponent();
-      Text = "HeuristicLab " + this.GetType().Assembly.GetName().Version;
+      FileVersionInfo pluginInfrastructureVersion = FileVersionInfo.GetVersionInfo(GetType().Assembly.Location);
+      Text = "HeuristicLab " + pluginInfrastructureVersion.FileVersion;
 
       string pluginPath = Path.GetFullPath(Application.StartupPath);
@@ -113,8 +114,8 @@
     private void UpdateApplicationsList() {
       applicationsListView.Items.Clear();
-
+      FileVersionInfo pluginInfrastructureVersion = FileVersionInfo.GetVersionInfo(GetType().Assembly.Location);
       pluginManagerListViewItem = new ListViewItem("Plugin Manager", 0);
       pluginManagerListViewItem.Group = applicationsListView.Groups["Plugin Management"];
-      pluginManagerListViewItem.SubItems.Add(new ListViewItem.ListViewSubItem(pluginManagerListViewItem, GetType().Assembly.GetName().Version.ToString()));
+      pluginManagerListViewItem.SubItems.Add(new ListViewItem.ListViewSubItem(pluginManagerListViewItem, pluginInfrastructureVersion.FileVersion));
       pluginManagerListViewItem.SubItems.Add(new ListViewItem.ListViewSubItem(pluginManagerListViewItem, "Install, upgrade or delete plugins"));
       pluginManagerListViewItem.ToolTipText = "Install, upgrade or delete plugins";
@@ -130,4 +131,9 @@
         item.ToolTipText = info.Description;
         applicationsListView.Items.Add(item);
+      }
+      foreach (ColumnHeader column in applicationsListView.Columns) {
+        if (applicationsListView.Items.Count > 0)
+          column.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        else column.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
       }
     }
@@ -165,4 +171,9 @@
     private void detailsButton_Click(object sender, EventArgs e) {
       applicationsListView.View = View.Details;
+      foreach (ColumnHeader column in applicationsListView.Columns) {
+        if (applicationsListView.Items.Count > 0)
+          column.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        else column.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
+      }
     }
 
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.resx
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.resx	(revision 3599)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.resx	(revision 3600)
@@ -213,4 +213,7 @@
 </value>
   </data>
+  <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>274, 17</value>
+  </metadata>
   <assembly alias="System.Drawing" name="System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
   <data name="$this.Icon" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">